package  
{
	import flash.display.MovieClip;
	import org.flixel.*;
	import org.flixel.plugin.funstorm.FlxMovieClip;
	
	/**
	 * ...
	 * @author Funstorm Ltd
	 */
	public class DemoState extends FlxState 
	{
		
		private var _textBounces:FlxText;
		private var _buttonPlay:FlxButton;
		private var _demoFlxMovieClip:FlxMovieClip;
		
		override public function create():void 
		{
			
			// Title Text
			var textTitle:FlxText = new FlxText(0, 25, FlxG.stage.stageWidth, "FlxMovieClip Demo");
			textTitle.setFormat(null, 14, 0xffffff, "center");
			add(textTitle);
			
			// Play/Stop Button
			_buttonPlay = new FlxButton(0, 60, "PLAY", button_play_click);
			_buttonPlay.x = FlxG.stage.stageWidth / 2 - _buttonPlay.width / 2;
			add(_buttonPlay);
			
			// Count Bounces Text
			_textBounces = new FlxText(0, 80, FlxG.stage.stageWidth, "0 Bounces");
			_textBounces.setFormat(null, 10, 0xffffff, "center");
			add(_textBounces);
			
			// The Movie Clip FlxSprite
			_demoFlxMovieClip = new FlxMovieClip();
			// Load a new instance of an embedded Flash MovieClip. Width and height must be set, the reset is optional.
			_demoFlxMovieClip.loadMovieClip(new MC_Smiley(), 105, 262, true, false, increment_bounce_text);
			// Change x & y position. Most typical FlxSprite variable can be changed (eg. scale, or angle).
			_demoFlxMovieClip.x = FlxG.stage.stageWidth / 2 - _demoFlxMovieClip.width / 2;
			_demoFlxMovieClip.y = FlxG.stage.stageHeight - _demoFlxMovieClip.height;
			add(_demoFlxMovieClip);
			
			FlxG.mouse.show();
		}
		
		/**
		 * Toggle MovieClip playback on/off and update button accordingly.
		 */
		private function button_play_click():void
		{
			if (_demoFlxMovieClip.isPlaying) {			// if it's already playing
				_demoFlxMovieClip.isPlaying = false;	//		then: stop it
				_buttonPlay.label.text = "PLAY";		//		then: change button text to play
			} else {									// if it's not playing
				_demoFlxMovieClip.isPlaying = true;		//		then: start it
				_buttonPlay.label.text = "STOP";		// 		then: change the button text to stop
			}
		}
		
		/**
		 * Called by the FlxMovieClip each time it reaches the end of the timeline.
		 * Increments and updates the "X Bounces" text.
		 */
		private function increment_bounce_text():void
		{
			var bounces:int = int(_textBounces.text.substr(0, _textBounces.text.length - String(" Bounces").length)); // extract current number of bounces from bounce text
			bounces += 1;
			_textBounces.text = String(bounces) + " Bounces";
		}
		
	}

}